/* Database.c generated by valac 0.36.3, the Vala compiler
 * generated from Database.vala, do not modify */

/*
 * Copyright 2015-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <stdarg.h>
#include <sqlite3.h>


#define DIORITEDB_TYPE_QUERYABLE (dioritedb_queryable_get_type ())
#define DIORITEDB_QUERYABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_QUERYABLE, DioritedbQueryable))
#define DIORITEDB_IS_QUERYABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_QUERYABLE))
#define DIORITEDB_QUERYABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DIORITEDB_TYPE_QUERYABLE, DioritedbQueryableIface))

typedef struct _DioritedbQueryable DioritedbQueryable;
typedef struct _DioritedbQueryableIface DioritedbQueryableIface;

#define DIORITEDB_TYPE_QUERY (dioritedb_query_get_type ())
#define DIORITEDB_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_QUERY, DioritedbQuery))
#define DIORITEDB_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_QUERY, DioritedbQueryClass))
#define DIORITEDB_IS_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_QUERY))
#define DIORITEDB_IS_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_QUERY))
#define DIORITEDB_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_QUERY, DioritedbQueryClass))

typedef struct _DioritedbQuery DioritedbQuery;
typedef struct _DioritedbQueryClass DioritedbQueryClass;

#define DIORITEDB_TYPE_OBJECT_QUERY (dioritedb_object_query_get_type ())
#define DIORITEDB_OBJECT_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_OBJECT_QUERY, DioritedbObjectQuery))
#define DIORITEDB_OBJECT_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_OBJECT_QUERY, DioritedbObjectQueryClass))
#define DIORITEDB_IS_OBJECT_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_OBJECT_QUERY))
#define DIORITEDB_IS_OBJECT_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_OBJECT_QUERY))
#define DIORITEDB_OBJECT_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_OBJECT_QUERY, DioritedbObjectQueryClass))

typedef struct _DioritedbObjectQuery DioritedbObjectQuery;
typedef struct _DioritedbObjectQueryClass DioritedbObjectQueryClass;

#define DIORITEDB_TYPE_DATABASE (dioritedb_database_get_type ())
#define DIORITEDB_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_DATABASE, DioritedbDatabase))
#define DIORITEDB_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_DATABASE, DioritedbDatabaseClass))
#define DIORITEDB_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_DATABASE))
#define DIORITEDB_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_DATABASE))
#define DIORITEDB_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_DATABASE, DioritedbDatabaseClass))

typedef struct _DioritedbDatabase DioritedbDatabase;
typedef struct _DioritedbDatabaseClass DioritedbDatabaseClass;
typedef struct _DioritedbDatabasePrivate DioritedbDatabasePrivate;

#define DIORITEDB_TYPE_ORM_MANAGER (dioritedb_orm_manager_get_type ())
#define DIORITEDB_ORM_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_ORM_MANAGER, DioritedbOrmManager))
#define DIORITEDB_ORM_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_ORM_MANAGER, DioritedbOrmManagerClass))
#define DIORITEDB_IS_ORM_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_ORM_MANAGER))
#define DIORITEDB_IS_ORM_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_ORM_MANAGER))
#define DIORITEDB_ORM_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_ORM_MANAGER, DioritedbOrmManagerClass))

typedef struct _DioritedbOrmManager DioritedbOrmManager;
typedef struct _DioritedbOrmManagerClass DioritedbOrmManagerClass;

#define DIORITEDB_TYPE_CONNECTION (dioritedb_connection_get_type ())
#define DIORITEDB_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_CONNECTION, DioritedbConnection))
#define DIORITEDB_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_CONNECTION, DioritedbConnectionClass))
#define DIORITEDB_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_CONNECTION))
#define DIORITEDB_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_CONNECTION))
#define DIORITEDB_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_CONNECTION, DioritedbConnectionClass))

typedef struct _DioritedbConnection DioritedbConnection;
typedef struct _DioritedbConnectionClass DioritedbConnectionClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _t_destroy_func0(var) (((var == NULL) || (t_destroy_func == NULL)) ? NULL : (var = (t_destroy_func (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))

typedef enum  {
	DIORITEDB_DATABASE_ERROR_UNKNOWN,
	DIORITEDB_DATABASE_ERROR_IOERROR,
	DIORITEDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DIORITEDB_DATABASE_ERROR_GENERAL,
	DIORITEDB_DATABASE_ERROR_RANGE,
	DIORITEDB_DATABASE_ERROR_DATA_TYPE,
	DIORITEDB_DATABASE_ERROR_NAME,
	DIORITEDB_DATABASE_ERROR_MISMATCH,
	DIORITEDB_DATABASE_ERROR_MISUSE,
	DIORITEDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DIORITEDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DioritedbDatabaseError;
#define DIORITEDB_DATABASE_ERROR dioritedb_database_error_quark ()
struct _DioritedbQueryableIface {
	GTypeInterface parent_iface;
	void (*exec) (DioritedbQueryable* self, const gchar* sql, GCancellable* cancellable, GError** error);
	DioritedbQuery* (*query) (DioritedbQueryable* self, const gchar* sql, GCancellable* cancellable, GError** error);
	DioritedbObjectQuery* (*get_objects) (DioritedbQueryable* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GCancellable* cancellable, GError** error);
	gpointer (*get_object) (DioritedbQueryable* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GValue* pk, GCancellable* cancellable, GError** error);
	const gchar* (*get_last_error_message) (DioritedbQueryable* self);
};

struct _DioritedbDatabase {
	GObject parent_instance;
	DioritedbDatabasePrivate * priv;
};

struct _DioritedbDatabaseClass {
	GObjectClass parent_class;
	void (*open) (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
	void (*close) (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
};

struct _DioritedbDatabasePrivate {
	GFile* _db_file;
	DioritedbOrmManager* _orm;
	gboolean _opened;
	GRecMutex __lock__opened;
	DioritedbConnection* master_connection;
};


static gpointer dioritedb_database_parent_class = NULL;
static DioritedbQueryableIface * dioritedb_database_dioritedb_queryable_parent_iface = NULL;

const gchar* sqlite3_errstr (gint errcode);
GQuark dioritedb_database_error_quark (void);
GType dioritedb_query_get_type (void) G_GNUC_CONST;
GType dioritedb_object_query_get_type (void) G_GNUC_CONST;
GType dioritedb_queryable_get_type (void) G_GNUC_CONST;
GType dioritedb_database_get_type (void) G_GNUC_CONST;
GType dioritedb_orm_manager_get_type (void) G_GNUC_CONST;
GType dioritedb_connection_get_type (void) G_GNUC_CONST;
#define DIORITEDB_DATABASE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITEDB_TYPE_DATABASE, DioritedbDatabasePrivate))
enum  {
	DIORITEDB_DATABASE_DUMMY_PROPERTY,
	DIORITEDB_DATABASE_DB_FILE,
	DIORITEDB_DATABASE_ORM,
	DIORITEDB_DATABASE_OPENED
};
DioritedbDatabase* dioritedb_database_new (GFile* db_file, DioritedbOrmManager* orm);
DioritedbDatabase* dioritedb_database_construct (GType object_type, GFile* db_file, DioritedbOrmManager* orm);
DioritedbOrmManager* dioritedb_orm_manager_new (void);
DioritedbOrmManager* dioritedb_orm_manager_construct (GType object_type);
void dioritedb_database_open (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
static void dioritedb_database_real_open (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
void dioritedb_throw_if_cancelled (GCancellable* cancellable, const gchar* method, const gchar* file, gint line, GError** error);
gboolean dioritedb_database_get_opened (DioritedbDatabase* self);
GFile* dioritedb_database_get_db_file (DioritedbDatabase* self);
DioritedbConnection* dioritedb_database_open_connection_internal (DioritedbDatabase* self, GCancellable* cancellable, gboolean master, GError** error);
static void dioritedb_database_set_opened (DioritedbDatabase* self, gboolean value);
void dioritedb_database_close (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
static void dioritedb_database_real_close (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
static void dioritedb_database_real_exec (DioritedbQueryable* base, const gchar* sql, GCancellable* cancellable, GError** error);
static DioritedbConnection* dioritedb_database_get_master_connection (DioritedbDatabase* self, GError** error);
void dioritedb_queryable_exec (DioritedbQueryable* self, const gchar* sql, GCancellable* cancellable, GError** error);
static DioritedbQuery* dioritedb_database_real_query (DioritedbQueryable* base, const gchar* sql, GCancellable* cancellable, GError** error);
DioritedbQuery* dioritedb_queryable_query (DioritedbQueryable* self, const gchar* sql, GCancellable* cancellable, GError** error);
DioritedbQuery* dioritedb_database_query_with_values (DioritedbDatabase* self, GCancellable* cancellable, const gchar* sql, GError** error, ...);
DioritedbQuery* dioritedb_connection_query_with_values_va (DioritedbConnection* self, GCancellable* cancellable, const gchar* sql, va_list args, GError** error);
DioritedbQuery* dioritedb_database_query_with_values_va (DioritedbDatabase* self, GCancellable* cancellable, const gchar* sql, va_list args, GError** error);
static DioritedbObjectQuery* dioritedb_database_real_get_objects (DioritedbQueryable* base, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GCancellable* cancellable, GError** error);
DioritedbObjectQuery* dioritedb_queryable_get_objects (DioritedbQueryable* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GCancellable* cancellable, GError** error);
DioritedbObjectQuery* dioritedb_database_query_objects (DioritedbDatabase* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GCancellable* cancellable, const gchar* sql_filter, GError** error, ...);
DioritedbObjectQuery* dioritedb_connection_query_objects_va (DioritedbConnection* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GCancellable* cancellable, const gchar* filter, va_list args, GError** error);
static gpointer dioritedb_database_real_get_object (DioritedbQueryable* base, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GValue* pk, GCancellable* cancellable, GError** error);
gpointer dioritedb_queryable_get_object (DioritedbQueryable* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GValue* pk, GCancellable* cancellable, GError** error);
static const gchar* dioritedb_database_real_get_last_error_message (DioritedbQueryable* base);
const gchar* dioritedb_queryable_get_last_error_message (DioritedbQueryable* self);
static inline void dioritedb_database_throw_if_not_opened (DioritedbDatabase* self, GError** error);
DioritedbConnection* dioritedb_database_open_connection (DioritedbDatabase* self, GCancellable* cancellable, GError** error);
gboolean dioritedb_is_sql_error (gint result_code);
GError* dioritedb_convert_sqlite_error (gint errno, const gchar* message, const gchar* sql, sqlite3_stmt* stm);
DioritedbOrmManager* dioritedb_database_get_orm (DioritedbDatabase* self);
DioritedbConnection* dioritedb_connection_new (sqlite3* db, DioritedbOrmManager* orm);
DioritedbConnection* dioritedb_connection_construct (GType object_type, sqlite3* db, DioritedbOrmManager* orm);
static void dioritedb_database_set_db_file (DioritedbDatabase* self, GFile* value);
static void dioritedb_database_set_orm (DioritedbDatabase* self, DioritedbOrmManager* value);
static void dioritedb_database_finalize (GObject * obj);
static void _vala_dioritedb_database_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_dioritedb_database_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Creates new database object
 * 
 * @param db_file    corresponding database file
 * @param orm        Object Relationship Mapping manager
 */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


DioritedbDatabase* dioritedb_database_construct (GType object_type, GFile* db_file, DioritedbOrmManager* orm) {
	DioritedbDatabase * self = NULL;
	DioritedbOrmManager* _tmp0_ = NULL;
	DioritedbOrmManager* _tmp1_;
	DioritedbOrmManager* _tmp2_;
	GFile* _tmp4_;
	DioritedbOrmManager* _tmp5_;
	DioritedbOrmManager* _tmp6_;
	g_return_val_if_fail (db_file != NULL, NULL);
	_tmp1_ = orm;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_tmp0_ = _tmp2_;
	if (_tmp0_ == NULL) {
		DioritedbOrmManager* _tmp3_;
		_tmp3_ = dioritedb_orm_manager_new ();
		_g_object_unref0 (_tmp0_);
		_tmp0_ = _tmp3_;
	}
	_tmp4_ = db_file;
	_tmp5_ = _tmp0_;
	_tmp0_ = NULL;
	_tmp6_ = _tmp5_;
	self = (DioritedbDatabase*) g_object_new (object_type, "db-file", _tmp4_, "orm", _tmp6_, NULL);
	_g_object_unref0 (_tmp6_);
	_g_object_unref0 (_tmp0_);
	return self;
}


DioritedbDatabase* dioritedb_database_new (GFile* db_file, DioritedbOrmManager* orm) {
	return dioritedb_database_construct (DIORITEDB_TYPE_DATABASE, db_file, orm);
}


/**
 * Open database.
 * 
 * Once database is opened, master connection can be used and new database connections can be created.
 * 
 * If database file does not exist, new empty database file is created.
 * 
 * @param cancellable    Cancellable object.
 * @throws GLib.Error when operation is cancelled.
 * @throws DatabaseError when database cannot be opened.
 */
static void dioritedb_database_real_open (DioritedbDatabase* self, GCancellable* cancellable, GError** error) {
	GCancellable* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GFile* db_dir = NULL;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GCancellable* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp10_ = FALSE;
	GFile* _tmp11_;
	GCancellable* _tmp12_;
	gboolean _tmp13_;
	DioritedbConnection* _tmp22_ = NULL;
	GCancellable* _tmp23_;
	DioritedbConnection* _tmp24_;
	DioritedbConnection* _tmp25_;
	GError * _inner_error_ = NULL;
	_tmp0_ = cancellable;
	dioritedb_throw_if_cancelled (_tmp0_, "Dioritedb.Database.open", "Database.vala", 85, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp1_ = dioritedb_database_get_opened (self);
	_tmp2_ = _tmp1_;
	g_return_if_fail (!_tmp2_);
	_tmp3_ = self->priv->_db_file;
	_tmp4_ = g_file_get_parent (_tmp3_);
	db_dir = _tmp4_;
	_tmp5_ = db_dir;
	_tmp6_ = cancellable;
	_tmp7_ = g_file_query_exists (_tmp5_, _tmp6_);
	if (!_tmp7_) {
		GFile* _tmp8_;
		GCancellable* _tmp9_;
		_tmp8_ = db_dir;
		_tmp9_ = cancellable;
		g_file_make_directory_with_parents (_tmp8_, _tmp9_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (db_dir);
			return;
		}
	}
	_tmp11_ = self->priv->_db_file;
	_tmp12_ = cancellable;
	_tmp13_ = g_file_query_exists (_tmp11_, _tmp12_);
	if (_tmp13_) {
		GFile* _tmp14_;
		GCancellable* _tmp15_;
		GFileType _tmp16_;
		_tmp14_ = self->priv->_db_file;
		_tmp15_ = cancellable;
		_tmp16_ = g_file_query_file_type (_tmp14_, 0, _tmp15_);
		_tmp10_ = _tmp16_ != G_FILE_TYPE_REGULAR;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		GFile* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		GError* _tmp20_;
		GError* _tmp21_;
		_tmp17_ = self->priv->_db_file;
		_tmp18_ = g_file_get_path (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_IOERROR, "'%s' exists, but is not a file.", _tmp19_);
		_tmp21_ = _tmp20_;
		_g_free0 (_tmp19_);
		_inner_error_ = _tmp21_;
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (db_dir);
		return;
	}
	_tmp23_ = cancellable;
	_tmp24_ = dioritedb_database_open_connection_internal (self, _tmp23_, TRUE, &_inner_error_);
	_tmp22_ = _tmp24_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (db_dir);
		return;
	}
	_tmp25_ = _tmp22_;
	_tmp22_ = NULL;
	_g_object_unref0 (self->priv->master_connection);
	self->priv->master_connection = _tmp25_;
	dioritedb_database_set_opened (self, TRUE);
	_g_object_unref0 (_tmp22_);
	_g_object_unref0 (db_dir);
}


void dioritedb_database_open (DioritedbDatabase* self, GCancellable* cancellable, GError** error) {
	g_return_if_fail (self != NULL);
	DIORITEDB_DATABASE_GET_CLASS (self)->open (self, cancellable, error);
}


/**
 * Close database
 * 
 * Once database is closed, master connection is also closed and new database connections cannot be created.
 * @param cancellable    Cancellable object
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
static void dioritedb_database_real_close (DioritedbDatabase* self, GCancellable* cancellable, GError** error) {
	GCancellable* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GError * _inner_error_ = NULL;
	_tmp0_ = cancellable;
	dioritedb_throw_if_cancelled (_tmp0_, "Dioritedb.Database.close", "Database.vala", 109, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp1_ = dioritedb_database_get_opened (self);
	_tmp2_ = _tmp1_;
	g_return_if_fail (_tmp2_);
	_g_object_unref0 (self->priv->master_connection);
	self->priv->master_connection = NULL;
	dioritedb_database_set_opened (self, FALSE);
}


void dioritedb_database_close (DioritedbDatabase* self, GCancellable* cancellable, GError** error) {
	g_return_if_fail (self != NULL);
	DIORITEDB_DATABASE_GET_CLASS (self)->close (self, cancellable, error);
}


/**
 * Execute a sql query on master database conection
 * 
 * @param sql            SQL query
 * @param cancellable    Cancellable object
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
static void dioritedb_database_real_exec (DioritedbQueryable* base, const gchar* sql, GCancellable* cancellable, GError** error) {
	DioritedbDatabase * self;
	DioritedbConnection* _tmp0_ = NULL;
	DioritedbConnection* _tmp1_;
	DioritedbConnection* _tmp2_;
	DioritedbConnection* _tmp3_;
	const gchar* _tmp4_;
	GCancellable* _tmp5_;
	GError * _inner_error_ = NULL;
	self = (DioritedbDatabase*) base;
	g_return_if_fail (sql != NULL);
	_tmp1_ = dioritedb_database_get_master_connection (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp2_ = _tmp0_;
	_tmp0_ = NULL;
	_tmp3_ = _tmp2_;
	_tmp4_ = sql;
	_tmp5_ = cancellable;
	dioritedb_queryable_exec ((DioritedbQueryable*) _tmp3_, _tmp4_, _tmp5_, &_inner_error_);
	_g_object_unref0 (_tmp3_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_tmp0_);
		return;
	}
	_g_object_unref0 (_tmp0_);
}


/**
 * Create new raw data query
 * 
 * After query is created, primitive data types can be bound prior execution.
 * 
 * @param sql            SQL query
 * @param cancellable    Cancellable object
 * @return new query object for further modifications prior execution
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
static DioritedbQuery* dioritedb_database_real_query (DioritedbQueryable* base, const gchar* sql, GCancellable* cancellable, GError** error) {
	DioritedbDatabase * self;
	DioritedbQuery* result = NULL;
	DioritedbConnection* _tmp0_ = NULL;
	DioritedbConnection* _tmp1_;
	DioritedbQuery* _tmp2_ = NULL;
	DioritedbConnection* _tmp3_;
	DioritedbConnection* _tmp4_;
	const gchar* _tmp5_;
	GCancellable* _tmp6_;
	DioritedbQuery* _tmp7_;
	DioritedbQuery* _tmp8_;
	DioritedbQuery* _tmp9_;
	GError * _inner_error_ = NULL;
	self = (DioritedbDatabase*) base;
	g_return_val_if_fail (sql != NULL, NULL);
	_tmp1_ = dioritedb_database_get_master_connection (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp3_ = _tmp0_;
	_tmp0_ = NULL;
	_tmp4_ = _tmp3_;
	_tmp5_ = sql;
	_tmp6_ = cancellable;
	_tmp7_ = dioritedb_queryable_query ((DioritedbQueryable*) _tmp4_, _tmp5_, _tmp6_, &_inner_error_);
	_tmp8_ = _tmp7_;
	_g_object_unref0 (_tmp4_);
	_tmp2_ = _tmp8_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_tmp0_);
		return NULL;
	}
	_tmp9_ = _tmp2_;
	_tmp2_ = NULL;
	result = _tmp9_;
	_g_object_unref0 (_tmp2_);
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Create new raw data query with values
 * 
 * After query is created, primitive data types can still be bound prior execution.
 * 
 * @param cancellable    Cancellable object
 * @param sql            SQL query with {@link BindExpression} syntax
 * @param ...            Values to be bound
 * @return new query object for further modifications prior execution
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
DioritedbQuery* dioritedb_database_query_with_values (DioritedbDatabase* self, GCancellable* cancellable, const gchar* sql, GError** error, ...) {
	DioritedbQuery* result = NULL;
	DioritedbConnection* _tmp0_ = NULL;
	DioritedbConnection* _tmp1_;
	DioritedbQuery* _tmp2_ = NULL;
	DioritedbConnection* _tmp3_;
	DioritedbConnection* _tmp4_;
	GCancellable* _tmp5_;
	const gchar* _tmp6_;
	va_list _tmp7_ = {0};
	DioritedbQuery* _tmp8_;
	DioritedbQuery* _tmp9_;
	DioritedbQuery* _tmp10_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (sql != NULL, NULL);
	_tmp1_ = dioritedb_database_get_master_connection (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp3_ = _tmp0_;
	_tmp0_ = NULL;
	_tmp4_ = _tmp3_;
	_tmp5_ = cancellable;
	_tmp6_ = sql;
	va_start (_tmp7_, error);
	_tmp8_ = dioritedb_connection_query_with_values_va (_tmp4_, _tmp5_, _tmp6_, _tmp7_, &_inner_error_);
	_tmp9_ = _tmp8_;
	va_end (_tmp7_);
	_g_object_unref0 (_tmp4_);
	_tmp2_ = _tmp9_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_tmp0_);
		return NULL;
	}
	_tmp10_ = _tmp2_;
	_tmp2_ = NULL;
	result = _tmp10_;
	_g_object_unref0 (_tmp2_);
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Create new raw data query with values
 * 
 * After query is created, primitive data types can still be bound prior execution.
 * 
 * @param cancellable    Cancellable object
 * @param sql            SQL query with {@link BindExpression} syntax
 * @param args           Values to be bound
 * @return new query object for further modifications prior execution
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
DioritedbQuery* dioritedb_database_query_with_values_va (DioritedbDatabase* self, GCancellable* cancellable, const gchar* sql, va_list args, GError** error) {
	DioritedbQuery* result = NULL;
	DioritedbConnection* _tmp0_ = NULL;
	DioritedbConnection* _tmp1_;
	DioritedbQuery* _tmp2_ = NULL;
	DioritedbConnection* _tmp3_;
	DioritedbConnection* _tmp4_;
	GCancellable* _tmp5_;
	const gchar* _tmp6_;
	DioritedbQuery* _tmp7_;
	DioritedbQuery* _tmp8_;
	DioritedbQuery* _tmp9_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (sql != NULL, NULL);
	_tmp1_ = dioritedb_database_get_master_connection (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp3_ = _tmp0_;
	_tmp0_ = NULL;
	_tmp4_ = _tmp3_;
	_tmp5_ = cancellable;
	_tmp6_ = sql;
	_tmp7_ = dioritedb_connection_query_with_values_va (_tmp4_, _tmp5_, _tmp6_, args, &_inner_error_);
	_tmp8_ = _tmp7_;
	_g_object_unref0 (_tmp4_);
	_tmp2_ = _tmp8_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_tmp0_);
		return NULL;
	}
	_tmp9_ = _tmp2_;
	_tmp2_ = NULL;
	result = _tmp9_;
	_g_object_unref0 (_tmp2_);
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Get ORM objects
 * 
 * @param cancellable    Cancellable object
 * @return new ORM query object
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
static DioritedbObjectQuery* dioritedb_database_real_get_objects (DioritedbQueryable* base, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GCancellable* cancellable, GError** error) {
	DioritedbDatabase * self;
	DioritedbObjectQuery* result = NULL;
	DioritedbConnection* _tmp0_ = NULL;
	DioritedbConnection* _tmp1_;
	DioritedbObjectQuery* _tmp2_ = NULL;
	DioritedbConnection* _tmp3_;
	DioritedbConnection* _tmp4_;
	GCancellable* _tmp5_;
	DioritedbObjectQuery* _tmp6_;
	DioritedbObjectQuery* _tmp7_;
	DioritedbObjectQuery* _tmp8_;
	GError * _inner_error_ = NULL;
	self = (DioritedbDatabase*) base;
	_tmp1_ = dioritedb_database_get_master_connection (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp3_ = _tmp0_;
	_tmp0_ = NULL;
	_tmp4_ = _tmp3_;
	_tmp5_ = cancellable;
	_tmp6_ = dioritedb_queryable_get_objects ((DioritedbQueryable*) _tmp4_, t_type, (GBoxedCopyFunc) t_dup_func, (GDestroyNotify) t_destroy_func, _tmp5_, &_inner_error_);
	_tmp7_ = _tmp6_;
	_g_object_unref0 (_tmp4_);
	_tmp2_ = _tmp7_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_tmp0_);
		return NULL;
	}
	_tmp8_ = _tmp2_;
	_tmp2_ = NULL;
	result = _tmp8_;
	_g_object_unref0 (_tmp2_);
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Create new ORM query
 * 
 * @param sql_filter     SQL conditions for filtering of objects (with {@link BindExpression})
 * @param cancellable    Cancellable object
 * @param ...            Data to bind to the query placeholders
 * @return new ORM query object
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
DioritedbObjectQuery* dioritedb_database_query_objects (DioritedbDatabase* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GCancellable* cancellable, const gchar* sql_filter, GError** error, ...) {
	DioritedbObjectQuery* result = NULL;
	DioritedbConnection* _tmp0_ = NULL;
	DioritedbConnection* _tmp1_;
	DioritedbObjectQuery* _tmp2_ = NULL;
	DioritedbConnection* _tmp3_;
	DioritedbConnection* _tmp4_;
	GCancellable* _tmp5_;
	const gchar* _tmp6_;
	va_list _tmp7_ = {0};
	DioritedbObjectQuery* _tmp8_;
	DioritedbObjectQuery* _tmp9_;
	DioritedbObjectQuery* _tmp10_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = dioritedb_database_get_master_connection (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp3_ = _tmp0_;
	_tmp0_ = NULL;
	_tmp4_ = _tmp3_;
	_tmp5_ = cancellable;
	_tmp6_ = sql_filter;
	va_start (_tmp7_, error);
	_tmp8_ = dioritedb_connection_query_objects_va (_tmp4_, t_type, (GBoxedCopyFunc) t_dup_func, (GDestroyNotify) t_destroy_func, _tmp5_, _tmp6_, _tmp7_, &_inner_error_);
	_tmp9_ = _tmp8_;
	va_end (_tmp7_);
	_g_object_unref0 (_tmp4_);
	_tmp2_ = _tmp9_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_tmp0_);
		return NULL;
	}
	_tmp10_ = _tmp2_;
	_tmp2_ = NULL;
	result = _tmp10_;
	_g_object_unref0 (_tmp2_);
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Get a single ORM object
 * 
 * @param pk             value of primary key
 * @param cancellable    Cancellable object
 * @return new ORM object
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
static gpointer dioritedb_database_real_get_object (DioritedbQueryable* base, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GValue* pk, GCancellable* cancellable, GError** error) {
	DioritedbDatabase * self;
	gpointer result = NULL;
	DioritedbConnection* _tmp0_ = NULL;
	DioritedbConnection* _tmp1_;
	gpointer _tmp2_ = NULL;
	DioritedbConnection* _tmp3_;
	DioritedbConnection* _tmp4_;
	GValue _tmp5_;
	GCancellable* _tmp6_;
	gpointer _tmp7_;
	gpointer _tmp8_;
	gpointer _tmp9_;
	GError * _inner_error_ = NULL;
	self = (DioritedbDatabase*) base;
	g_return_val_if_fail (pk != NULL, NULL);
	_tmp1_ = dioritedb_database_get_master_connection (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp3_ = _tmp0_;
	_tmp0_ = NULL;
	_tmp4_ = _tmp3_;
	_tmp5_ = *pk;
	_tmp6_ = cancellable;
	_tmp7_ = dioritedb_queryable_get_object ((DioritedbQueryable*) _tmp4_, t_type, (GBoxedCopyFunc) t_dup_func, (GDestroyNotify) t_destroy_func, &_tmp5_, _tmp6_, &_inner_error_);
	_tmp8_ = _tmp7_;
	_g_object_unref0 (_tmp4_);
	_tmp2_ = _tmp8_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_tmp0_);
		return NULL;
	}
	_tmp9_ = _tmp2_;
	_tmp2_ = NULL;
	result = _tmp9_;
	_t_destroy_func0 (_tmp2_);
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Return last error message
 * 
 * @return the last error message
 */
static const gchar* dioritedb_database_real_get_last_error_message (DioritedbQueryable* base) {
	DioritedbDatabase * self;
	const gchar* result = NULL;
	GError * _inner_error_ = NULL;
	self = (DioritedbDatabase*) base;
	{
		DioritedbConnection* _tmp0_ = NULL;
		DioritedbConnection* _tmp1_;
		DioritedbConnection* _tmp2_;
		DioritedbConnection* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		_tmp1_ = dioritedb_database_get_master_connection (self, &_inner_error_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
				goto __catch0_dioritedb_database_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_tmp3_ = _tmp2_;
		_tmp4_ = dioritedb_queryable_get_last_error_message ((DioritedbQueryable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		result = _tmp5_;
		_g_object_unref0 (_tmp0_);
		return result;
	}
	goto __finally0;
	__catch0_dioritedb_database_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		result = NULL;
		_g_error_free0 (e);
		return result;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


/**
 * Get master database connection
 * 
 * @throws DatabaseError when database is closed
 * @return master database connection
 */
static DioritedbConnection* dioritedb_database_get_master_connection (DioritedbDatabase* self, GError** error) {
	DioritedbConnection* result = NULL;
	DioritedbConnection* _tmp0_;
	DioritedbConnection* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	dioritedb_database_throw_if_not_opened (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp0_ = self->priv->master_connection;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * Open new database connection
 * @param cancellable    Cancellable object
 * @return new database connection
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
DioritedbConnection* dioritedb_database_open_connection (DioritedbDatabase* self, GCancellable* cancellable, GError** error) {
	DioritedbConnection* result = NULL;
	DioritedbConnection* _tmp0_ = NULL;
	GCancellable* _tmp1_;
	DioritedbConnection* _tmp2_;
	DioritedbConnection* _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = cancellable;
	_tmp2_ = dioritedb_database_open_connection_internal (self, _tmp1_, FALSE, &_inner_error_);
	_tmp0_ = _tmp2_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp3_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp3_;
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Open new database connection
 * @param cancellable    Cancellable object
 * @param master         If the master connection is to be opened
 * @return new database connection
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
DioritedbConnection* dioritedb_database_open_connection_internal (DioritedbDatabase* self, GCancellable* cancellable, gboolean master, GError** error) {
	DioritedbConnection* result = NULL;
	GCancellable* _tmp0_;
	gboolean _tmp1_;
	sqlite3* db = NULL;
	gint _result_ = 0;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	sqlite3* _tmp5_ = NULL;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gboolean _tmp9_;
	sqlite3* _tmp18_;
	DioritedbOrmManager* _tmp19_;
	DioritedbConnection* _tmp20_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = cancellable;
	dioritedb_throw_if_cancelled (_tmp0_, "Dioritedb.Database.open_connection_internal", "Database.vala", 275, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp1_ = master;
	if (!_tmp1_) {
		dioritedb_database_throw_if_not_opened (self, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		}
	}
	_tmp2_ = self->priv->_db_file;
	_tmp3_ = g_file_get_path (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp6_ = sqlite3_open_v2 (_tmp4_, &_tmp5_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
	_sqlite3_close0 (db);
	db = _tmp5_;
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp4_);
	_result_ = _tmp7_;
	_tmp8_ = _result_;
	_tmp9_ = dioritedb_is_sql_error (_tmp8_);
	if (_tmp9_) {
		const gchar* _tmp10_ = NULL;
		sqlite3* _tmp11_;
		gint _tmp16_;
		GError* _tmp17_;
		_tmp11_ = db;
		if (_tmp11_ != NULL) {
			sqlite3* _tmp12_;
			const gchar* _tmp13_;
			_tmp12_ = db;
			_tmp13_ = sqlite3_errmsg (_tmp12_);
			_tmp10_ = _tmp13_;
		} else {
			gint _tmp14_;
			const gchar* _tmp15_;
			_tmp14_ = _result_;
			_tmp15_ = sqlite3_errstr (_tmp14_);
			_tmp10_ = _tmp15_;
		}
		_tmp16_ = _result_;
		_tmp17_ = dioritedb_convert_sqlite_error (_tmp16_, _tmp10_, NULL, NULL);
		_inner_error_ = _tmp17_;
		g_propagate_error (error, _inner_error_);
		_sqlite3_close0 (db);
		return NULL;
	}
	_tmp18_ = db;
	db = NULL;
	_tmp19_ = self->priv->_orm;
	_tmp20_ = dioritedb_connection_new (_tmp18_, _tmp19_);
	result = _tmp20_;
	_sqlite3_close0 (db);
	return result;
}


/**
 * Throw an error if database is closed
 * 
 * @throws DatabaseError if database is closed
 */
static inline void dioritedb_database_throw_if_not_opened (DioritedbDatabase* self, GError** error) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = dioritedb_database_get_opened (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
		_tmp2_ = self->priv->_db_file;
		_tmp3_ = g_file_get_path (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_error_new (DIORITEDB_DATABASE_ERROR, DIORITEDB_DATABASE_ERROR_DATABASE_NOT_OPENED, "Database '%s' is not opened.", _tmp4_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		_inner_error_ = _tmp6_;
		if (_inner_error_->domain == DIORITEDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


GFile* dioritedb_database_get_db_file (DioritedbDatabase* self) {
	GFile* result;
	GFile* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_db_file;
	result = _tmp0_;
	return result;
}


static void dioritedb_database_set_db_file (DioritedbDatabase* self, GFile* value) {
	g_return_if_fail (self != NULL);
	if (dioritedb_database_get_db_file (self) != value) {
		GFile* _tmp0_;
		GFile* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_db_file);
		self->priv->_db_file = _tmp1_;
		g_object_notify ((GObject *) self, "db-file");
	}
}


DioritedbOrmManager* dioritedb_database_get_orm (DioritedbDatabase* self) {
	DioritedbOrmManager* result;
	DioritedbOrmManager* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_orm;
	result = _tmp0_;
	return result;
}


static void dioritedb_database_set_orm (DioritedbDatabase* self, DioritedbOrmManager* value) {
	g_return_if_fail (self != NULL);
	if (dioritedb_database_get_orm (self) != value) {
		DioritedbOrmManager* _tmp0_;
		DioritedbOrmManager* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_orm);
		self->priv->_orm = _tmp1_;
		g_object_notify ((GObject *) self, "orm");
	}
}


gboolean dioritedb_database_get_opened (DioritedbDatabase* self) {
	gboolean result;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gboolean _tmp0_;
		gboolean _tmp4_ = FALSE;
		_tmp0_ = self->priv->_opened;
		g_rec_mutex_lock (&self->priv->__lock__opened);
		{
			gboolean _tmp1_;
			_tmp1_ = self->priv->_opened;
			result = _tmp1_;
			{
				gboolean _tmp2_;
				_tmp2_ = self->priv->_opened;
				g_rec_mutex_unlock (&self->priv->__lock__opened);
			}
			return result;
		}
		__finally1:
		{
			gboolean _tmp3_;
			_tmp3_ = self->priv->_opened;
			g_rec_mutex_unlock (&self->priv->__lock__opened);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp4_;
	}
}


static void dioritedb_database_set_opened (DioritedbDatabase* self, gboolean value) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		gboolean _tmp0_;
		_tmp0_ = self->priv->_opened;
		g_rec_mutex_lock (&self->priv->__lock__opened);
		{
			gboolean _tmp1_;
			_tmp1_ = value;
			self->priv->_opened = _tmp1_;
		}
		__finally2:
		{
			gboolean _tmp2_;
			_tmp2_ = self->priv->_opened;
			g_rec_mutex_unlock (&self->priv->__lock__opened);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	g_object_notify ((GObject *) self, "opened");
}


static void dioritedb_database_class_init (DioritedbDatabaseClass * klass) {
	dioritedb_database_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DioritedbDatabasePrivate));
	((DioritedbDatabaseClass *) klass)->open = (void (*) (DioritedbDatabase *, GCancellable*, GError**)) dioritedb_database_real_open;
	((DioritedbDatabaseClass *) klass)->close = (void (*) (DioritedbDatabase *, GCancellable*, GError**)) dioritedb_database_real_close;
	G_OBJECT_CLASS (klass)->get_property = _vala_dioritedb_database_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dioritedb_database_set_property;
	G_OBJECT_CLASS (klass)->finalize = dioritedb_database_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITEDB_DATABASE_DB_FILE, g_param_spec_object ("db-file", "db-file", "db-file", g_file_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITEDB_DATABASE_ORM, g_param_spec_object ("orm", "orm", "orm", DIORITEDB_TYPE_ORM_MANAGER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITEDB_DATABASE_OPENED, g_param_spec_boolean ("opened", "opened", "opened", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void dioritedb_database_dioritedb_queryable_interface_init (DioritedbQueryableIface * iface) {
	dioritedb_database_dioritedb_queryable_parent_iface = g_type_interface_peek_parent (iface);
	iface->exec = (void (*) (DioritedbQueryable *, const gchar*, GCancellable*, GError**)) dioritedb_database_real_exec;
	iface->query = (DioritedbQuery* (*) (DioritedbQueryable *, const gchar*, GCancellable*, GError**)) dioritedb_database_real_query;
	iface->get_objects = (DioritedbObjectQuery* (*) (DioritedbQueryable *, GType, GBoxedCopyFunc, GDestroyNotify, GCancellable*, GError**)) dioritedb_database_real_get_objects;
	iface->get_object = (gpointer (*) (DioritedbQueryable *, GType, GBoxedCopyFunc, GDestroyNotify, GValue*, GCancellable*, GError**)) dioritedb_database_real_get_object;
	iface->get_last_error_message = (const gchar* (*) (DioritedbQueryable *)) dioritedb_database_real_get_last_error_message;
}


static void dioritedb_database_instance_init (DioritedbDatabase * self) {
	self->priv = DIORITEDB_DATABASE_GET_PRIVATE (self);
	g_rec_mutex_init (&self->priv->__lock__opened);
	self->priv->_opened = FALSE;
	self->priv->master_connection = NULL;
}


static void dioritedb_database_finalize (GObject * obj) {
	DioritedbDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITEDB_TYPE_DATABASE, DioritedbDatabase);
	_g_object_unref0 (self->priv->_db_file);
	_g_object_unref0 (self->priv->_orm);
	g_rec_mutex_clear (&self->priv->__lock__opened);
	_g_object_unref0 (self->priv->master_connection);
	G_OBJECT_CLASS (dioritedb_database_parent_class)->finalize (obj);
}


/**
 * SQLite database object
 */
GType dioritedb_database_get_type (void) {
	static volatile gsize dioritedb_database_type_id__volatile = 0;
	if (g_once_init_enter (&dioritedb_database_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioritedbDatabaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dioritedb_database_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioritedbDatabase), 0, (GInstanceInitFunc) dioritedb_database_instance_init, NULL };
		static const GInterfaceInfo dioritedb_queryable_info = { (GInterfaceInitFunc) dioritedb_database_dioritedb_queryable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType dioritedb_database_type_id;
		dioritedb_database_type_id = g_type_register_static (G_TYPE_OBJECT, "DioritedbDatabase", &g_define_type_info, 0);
		g_type_add_interface_static (dioritedb_database_type_id, DIORITEDB_TYPE_QUERYABLE, &dioritedb_queryable_info);
		g_once_init_leave (&dioritedb_database_type_id__volatile, dioritedb_database_type_id);
	}
	return dioritedb_database_type_id__volatile;
}


static void _vala_dioritedb_database_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DioritedbDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITEDB_TYPE_DATABASE, DioritedbDatabase);
	switch (property_id) {
		case DIORITEDB_DATABASE_DB_FILE:
		g_value_set_object (value, dioritedb_database_get_db_file (self));
		break;
		case DIORITEDB_DATABASE_ORM:
		g_value_set_object (value, dioritedb_database_get_orm (self));
		break;
		case DIORITEDB_DATABASE_OPENED:
		g_value_set_boolean (value, dioritedb_database_get_opened (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_dioritedb_database_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DioritedbDatabase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITEDB_TYPE_DATABASE, DioritedbDatabase);
	switch (property_id) {
		case DIORITEDB_DATABASE_DB_FILE:
		dioritedb_database_set_db_file (self, g_value_get_object (value));
		break;
		case DIORITEDB_DATABASE_ORM:
		dioritedb_database_set_orm (self, g_value_get_object (value));
		break;
		case DIORITEDB_DATABASE_OPENED:
		dioritedb_database_set_opened (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



