/* ObjectCursor.c generated by valac 0.36.3, the Vala compiler
 * generated from ObjectCursor.vala, do not modify */

/*
 * Copyright 2015-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define DIORITEDB_TYPE_OBJECT_CURSOR (dioritedb_object_cursor_get_type ())
#define DIORITEDB_OBJECT_CURSOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_OBJECT_CURSOR, DioritedbObjectCursor))
#define DIORITEDB_OBJECT_CURSOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_OBJECT_CURSOR, DioritedbObjectCursorClass))
#define DIORITEDB_IS_OBJECT_CURSOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_OBJECT_CURSOR))
#define DIORITEDB_IS_OBJECT_CURSOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_OBJECT_CURSOR))
#define DIORITEDB_OBJECT_CURSOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_OBJECT_CURSOR, DioritedbObjectCursorClass))

typedef struct _DioritedbObjectCursor DioritedbObjectCursor;
typedef struct _DioritedbObjectCursorClass DioritedbObjectCursorClass;
typedef struct _DioritedbObjectCursorPrivate DioritedbObjectCursorPrivate;

#define DIORITEDB_TYPE_ORM_MANAGER (dioritedb_orm_manager_get_type ())
#define DIORITEDB_ORM_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_ORM_MANAGER, DioritedbOrmManager))
#define DIORITEDB_ORM_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_ORM_MANAGER, DioritedbOrmManagerClass))
#define DIORITEDB_IS_ORM_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_ORM_MANAGER))
#define DIORITEDB_IS_ORM_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_ORM_MANAGER))
#define DIORITEDB_ORM_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_ORM_MANAGER, DioritedbOrmManagerClass))

typedef struct _DioritedbOrmManager DioritedbOrmManager;
typedef struct _DioritedbOrmManagerClass DioritedbOrmManagerClass;

#define DIORITEDB_TYPE_RESULT (dioritedb_result_get_type ())
#define DIORITEDB_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITEDB_TYPE_RESULT, DioritedbResult))
#define DIORITEDB_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITEDB_TYPE_RESULT, DioritedbResultClass))
#define DIORITEDB_IS_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITEDB_TYPE_RESULT))
#define DIORITEDB_IS_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITEDB_TYPE_RESULT))
#define DIORITEDB_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITEDB_TYPE_RESULT, DioritedbResultClass))

typedef struct _DioritedbResult DioritedbResult;
typedef struct _DioritedbResultClass DioritedbResultClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _DioritedbParamSpecObjectCursor DioritedbParamSpecObjectCursor;

struct _DioritedbObjectCursor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DioritedbObjectCursorPrivate * priv;
};

struct _DioritedbObjectCursorClass {
	GTypeClass parent_class;
	void (*finalize) (DioritedbObjectCursor *self);
};

struct _DioritedbObjectCursorPrivate {
	GType t_type;
	GBoxedCopyFunc t_dup_func;
	GDestroyNotify t_destroy_func;
	guint _counter;
	DioritedbOrmManager* orm;
	GCancellable* cancellable;
	DioritedbResult* result;
};

typedef enum  {
	DIORITEDB_DATABASE_ERROR_UNKNOWN,
	DIORITEDB_DATABASE_ERROR_IOERROR,
	DIORITEDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DIORITEDB_DATABASE_ERROR_GENERAL,
	DIORITEDB_DATABASE_ERROR_RANGE,
	DIORITEDB_DATABASE_ERROR_DATA_TYPE,
	DIORITEDB_DATABASE_ERROR_NAME,
	DIORITEDB_DATABASE_ERROR_MISMATCH,
	DIORITEDB_DATABASE_ERROR_MISUSE,
	DIORITEDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DIORITEDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DioritedbDatabaseError;
#define DIORITEDB_DATABASE_ERROR dioritedb_database_error_quark ()
struct _DioritedbParamSpecObjectCursor {
	GParamSpec parent_instance;
};


static gpointer dioritedb_object_cursor_parent_class = NULL;

gpointer dioritedb_object_cursor_ref (gpointer instance);
void dioritedb_object_cursor_unref (gpointer instance);
GParamSpec* dioritedb_param_spec_object_cursor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void dioritedb_value_set_object_cursor (GValue* value, gpointer v_object);
void dioritedb_value_take_object_cursor (GValue* value, gpointer v_object);
gpointer dioritedb_value_get_object_cursor (const GValue* value);
GType dioritedb_object_cursor_get_type (void) G_GNUC_CONST;
GType dioritedb_orm_manager_get_type (void) G_GNUC_CONST;
GType dioritedb_result_get_type (void) G_GNUC_CONST;
#define DIORITEDB_OBJECT_CURSOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITEDB_TYPE_OBJECT_CURSOR, DioritedbObjectCursorPrivate))
enum  {
	DIORITEDB_OBJECT_CURSOR_DUMMY_PROPERTY
};
DioritedbObjectCursor* dioritedb_object_cursor_new (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, DioritedbOrmManager* orm, DioritedbResult* _result_, GCancellable* cancellable);
DioritedbObjectCursor* dioritedb_object_cursor_construct (GType object_type, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, DioritedbOrmManager* orm, DioritedbResult* _result_, GCancellable* cancellable);
DioritedbObjectCursor* dioritedb_object_cursor_iterator (DioritedbObjectCursor* self);
GQuark dioritedb_database_error_quark (void);
gboolean dioritedb_object_cursor_next (DioritedbObjectCursor* self, GError** error);
gboolean dioritedb_result_next (DioritedbResult* self, GCancellable* cancellable, GError** error);
guint dioritedb_object_cursor_get_counter (DioritedbObjectCursor* self);
static void dioritedb_object_cursor_set_counter (DioritedbObjectCursor* self, guint value);
gpointer dioritedb_object_cursor_get (DioritedbObjectCursor* self, GError** error);
gpointer dioritedb_orm_manager_create_object (DioritedbOrmManager* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, DioritedbResult* _result_, GError** error);
static void dioritedb_object_cursor_finalize (DioritedbObjectCursor * obj);


/**
 * Creates new ObjectCursor
 * 
 * @param orm            ORM manager
 * @param result         the result of ORM query
 * @param cancellable    Cancelable object
 */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


DioritedbObjectCursor* dioritedb_object_cursor_construct (GType object_type, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, DioritedbOrmManager* orm, DioritedbResult* _result_, GCancellable* cancellable) {
	DioritedbObjectCursor* self = NULL;
	DioritedbOrmManager* _tmp0_;
	DioritedbOrmManager* _tmp1_;
	DioritedbResult* _tmp2_;
	DioritedbResult* _tmp3_;
	GCancellable* _tmp4_;
	GCancellable* _tmp5_;
	g_return_val_if_fail (orm != NULL, NULL);
	g_return_val_if_fail (_result_ != NULL, NULL);
	self = (DioritedbObjectCursor*) g_type_create_instance (object_type);
	self->priv->t_type = t_type;
	self->priv->t_dup_func = t_dup_func;
	self->priv->t_destroy_func = t_destroy_func;
	_tmp0_ = orm;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->orm);
	self->priv->orm = _tmp1_;
	_tmp2_ = _result_;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->result);
	self->priv->result = _tmp3_;
	_tmp4_ = cancellable;
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_g_object_unref0 (self->priv->cancellable);
	self->priv->cancellable = _tmp5_;
	return self;
}


DioritedbObjectCursor* dioritedb_object_cursor_new (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, DioritedbOrmManager* orm, DioritedbResult* _result_, GCancellable* cancellable) {
	return dioritedb_object_cursor_construct (DIORITEDB_TYPE_OBJECT_CURSOR, t_type, t_dup_func, t_destroy_func, orm, _result_, cancellable);
}


/**
 * Return iterator.
 * 
 * @return `this` object
 */
static gpointer _dioritedb_object_cursor_ref0 (gpointer self) {
	return self ? dioritedb_object_cursor_ref (self) : NULL;
}


DioritedbObjectCursor* dioritedb_object_cursor_iterator (DioritedbObjectCursor* self) {
	DioritedbObjectCursor* result = NULL;
	DioritedbObjectCursor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = _dioritedb_object_cursor_ref0 (self);
	result = _tmp0_;
	return result;
}


/**
 * Advance the cursor
 * 
 * @return `true` if there is still data
 */
gboolean dioritedb_object_cursor_next (DioritedbObjectCursor* self, GError** error) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	DioritedbResult* _tmp1_;
	gboolean _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->priv->result;
	_tmp2_ = dioritedb_result_next (_tmp1_, NULL, &_inner_error_);
	_tmp0_ = _tmp2_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp3_ = FALSE;
		g_propagate_error (error, _inner_error_);
		return _tmp3_;
	}
	if (_tmp0_) {
		guint _tmp4_;
		_tmp4_ = self->priv->_counter;
		dioritedb_object_cursor_set_counter (self, _tmp4_ + 1);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


/**
 * Get object under cursor
 * 
 * @return current object
 */
gpointer dioritedb_object_cursor_get (DioritedbObjectCursor* self, GError** error) {
	gpointer result = NULL;
	gpointer _tmp0_ = NULL;
	DioritedbOrmManager* _tmp1_;
	DioritedbResult* _tmp2_;
	gpointer _tmp3_;
	gpointer _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->orm;
	_tmp2_ = self->priv->result;
	_tmp3_ = dioritedb_orm_manager_create_object (_tmp1_, self->priv->t_type, (GBoxedCopyFunc) self->priv->t_dup_func, (GDestroyNotify) self->priv->t_destroy_func, _tmp2_, &_inner_error_);
	_tmp0_ = _tmp3_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp4_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp4_;
	((_tmp0_ == NULL) || (self->priv->t_destroy_func == NULL)) ? NULL : (_tmp0_ = (self->priv->t_destroy_func (_tmp0_), NULL));
	return result;
}


guint dioritedb_object_cursor_get_counter (DioritedbObjectCursor* self) {
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_counter;
	result = _tmp0_;
	return result;
}


static void dioritedb_object_cursor_set_counter (DioritedbObjectCursor* self, guint value) {
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_counter = _tmp0_;
}


static void dioritedb_value_object_cursor_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void dioritedb_value_object_cursor_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		dioritedb_object_cursor_unref (value->data[0].v_pointer);
	}
}


static void dioritedb_value_object_cursor_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = dioritedb_object_cursor_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer dioritedb_value_object_cursor_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* dioritedb_value_object_cursor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DioritedbObjectCursor * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = dioritedb_object_cursor_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* dioritedb_value_object_cursor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DioritedbObjectCursor ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = dioritedb_object_cursor_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* dioritedb_param_spec_object_cursor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DioritedbParamSpecObjectCursor* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DIORITEDB_TYPE_OBJECT_CURSOR), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer dioritedb_value_get_object_cursor (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITEDB_TYPE_OBJECT_CURSOR), NULL);
	return value->data[0].v_pointer;
}


void dioritedb_value_set_object_cursor (GValue* value, gpointer v_object) {
	DioritedbObjectCursor * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITEDB_TYPE_OBJECT_CURSOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITEDB_TYPE_OBJECT_CURSOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		dioritedb_object_cursor_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		dioritedb_object_cursor_unref (old);
	}
}


void dioritedb_value_take_object_cursor (GValue* value, gpointer v_object) {
	DioritedbObjectCursor * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIORITEDB_TYPE_OBJECT_CURSOR));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIORITEDB_TYPE_OBJECT_CURSOR));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		dioritedb_object_cursor_unref (old);
	}
}


static void dioritedb_object_cursor_class_init (DioritedbObjectCursorClass * klass) {
	dioritedb_object_cursor_parent_class = g_type_class_peek_parent (klass);
	((DioritedbObjectCursorClass *) klass)->finalize = dioritedb_object_cursor_finalize;
	g_type_class_add_private (klass, sizeof (DioritedbObjectCursorPrivate));
}


static void dioritedb_object_cursor_instance_init (DioritedbObjectCursor * self) {
	self->priv = DIORITEDB_OBJECT_CURSOR_GET_PRIVATE (self);
	self->priv->_counter = (guint) 0;
	self->ref_count = 1;
}


static void dioritedb_object_cursor_finalize (DioritedbObjectCursor * obj) {
	DioritedbObjectCursor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITEDB_TYPE_OBJECT_CURSOR, DioritedbObjectCursor);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->orm);
	_g_object_unref0 (self->priv->cancellable);
	_g_object_unref0 (self->priv->result);
}


/**
 * Cursor to browse set of ORM objects
 */
GType dioritedb_object_cursor_get_type (void) {
	static volatile gsize dioritedb_object_cursor_type_id__volatile = 0;
	if (g_once_init_enter (&dioritedb_object_cursor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { dioritedb_value_object_cursor_init, dioritedb_value_object_cursor_free_value, dioritedb_value_object_cursor_copy_value, dioritedb_value_object_cursor_peek_pointer, "p", dioritedb_value_object_cursor_collect_value, "p", dioritedb_value_object_cursor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DioritedbObjectCursorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dioritedb_object_cursor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioritedbObjectCursor), 0, (GInstanceInitFunc) dioritedb_object_cursor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType dioritedb_object_cursor_type_id;
		dioritedb_object_cursor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DioritedbObjectCursor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&dioritedb_object_cursor_type_id__volatile, dioritedb_object_cursor_type_id);
	}
	return dioritedb_object_cursor_type_id__volatile;
}


gpointer dioritedb_object_cursor_ref (gpointer instance) {
	DioritedbObjectCursor * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void dioritedb_object_cursor_unref (gpointer instance) {
	DioritedbObjectCursor * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DIORITEDB_OBJECT_CURSOR_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



